// Programmierzeit Prof. Brass (ohne main): 8 Minuten (19:06 Ende: 19:14)

class Raetsel {
    public static void main(String[] args) {
        ZustandsListe liste = new ZustandsListe();
        liste.add(new Zustand(8, 0, 0));
        for(int n = 0; n < liste.size(); n++) {
            Zustand z = liste.get(n);
            z.print();
            // Alle Moeglichkeiten, von Eimer i in Eimer j umzufuellen,
            // werden durchprobiert, und die neuen Zustaende in die
            // Liste eingetragen (bis keine neuen Zustaende mehr):
            for(int i = 0; i < 3; i++)
                for(int j = 0; j < 3; j++)
                    if(i != j)
                        liste.add(umfuellen(z, i, j));
        }
        System.out.println("Insgesamt " + liste.size() + " Zustaende.");
        for(int n = 0; n < liste.size(); n++) {
            if(liste.get(n).gesucht()) {
                System.out.println("Raetsel ist loesbar!");
                return;
            }
        }
        System.out.println("Raetsel nicht loesbar");
    }

    static Zustand umfuellen(Zustand z, int i, int j) {
        int[] inhalte = new int[3];
        inhalte[0] = z.inhalt(0);
        inhalte[1] = z.inhalt(1);
        inhalte[2] = z.inhalt(2);
	int menge = 0;
	if(j == 0)
		menge = 8 - z.inhalt(0);
	else if(j == 1)
		menge = 5 - z.inhalt(1);
	else
		menge = 3 - z.inhalt(2);
	if(z.inhalt(i) < menge)
		menge = z.inhalt(i);
	if(menge == 0)
		return null;
	inhalte[i] -= menge;
	inhalte[j] += menge;
	return new Zustand(inhalte[0], inhalte[1], inhalte[2]);
    }
}
